import { __require } from './chunk-MXFP7CYD.mjs';
import { readFile } from 'node:fs/promises';
import { basename } from 'node:path';
import { logger } from 'storybook/internal/node-logger';
import { preprocess } from 'svelte/compiler';
import svelteDoc from 'sveltedoc-parser';
import { dedent } from 'ts-dedent';

var svelteDocParserOptions=__require("sveltedoc-parser/lib/options.js");svelteDocParserOptions.getAstDefaultOptions=()=>({range:!0,loc:!0,comment:!0,tokens:!0,ecmaVersion:12,sourceType:"module",ecmaFeatures:{}});function getNameFromFilename(filename){if(!filename)return null;let parts=filename.split(/[/\\]/).map(encodeURI);if(parts.length>1){let index_match=parts[parts.length-1].match(/^index(\.\w+)/);index_match&&(parts.pop(),parts[parts.length-1]+=index_match[1]);}let value=parts.pop();if(!value)throw new Error(`Could not derive component name from file ${filename}`);let base=value.replace(/%/g,"u").replace(/\.[^.]+$/,"").replace(/[^a-zA-Z_$0-9]+/g,"_").replace(/^_/,"").replace(/_$/,"").replace(/^(\d)/,"_$1");if(!base)throw new Error(`Could not derive component name from file ${filename}`);return base[0].toUpperCase()+base.slice(1)}async function svelteDocgen(source){let{resource}=this._module,svelteOptions=this.getOptions(),{preprocess:preprocessOptions,logDocgen=!1}=svelteOptions,docOptions;if(preprocessOptions){let src=await readFile(resource).toString(),{code:fileContent}=await preprocess(src,preprocessOptions);docOptions={fileContent};}else docOptions={filename:resource};let options={...docOptions,version:3},docgen="",componentDoc;try{componentDoc=await svelteDoc.parse(options);}catch(error){componentDoc={keywords:[],data:[]},logDocgen&&logger.error(error);}let file=basename(resource);componentDoc.name=basename(file);let componentName=getNameFromFilename(resource);return docgen=dedent`
      ${componentName}.__docgen = ${JSON.stringify(componentDoc)};
    `,source+docgen}

export { svelteDocgen as default };
